


//www.cnblogs.com/flyinghearts    flyinghearts # qq.com

#include <algorithm>
#include <limits>
#include <vector>
#include <cstdio>

#define NOMINMAX 1
#include <windows.h>

#define TEST_CASE 1                  // 0黹ǵ1
#define RANDOM_SHUFFLE 0             // Ƿͨϴƻ


#define TEST_RAND_POS 0              
const unsigned Pack = 4;     // ĳPackΣȡƽֵ
const unsigned Rand_M = 5;   // ĳ Rand_M
#if ! TEST_CASE                      
 const unsigned Fix_M = 3;      // ̶鳤ʱFix_M
 const unsigned Length = 6e7;   // ̶鳤
#else
 const unsigned Fix_M = 10;  
 const unsigned Length = 1e8;  
#endif

#if _MSC_VER
  #pragma comment(lib, "winmm.lib")
#endif

inline unsigned mclock() { return timeGetTime(); }

void solve_1a(const int arr[], const size_t len, int& min_value, int& max_value)
{
  min_value = max_value = arr[0];
  for (const int *p = arr + 1; p < arr + len; ++p) 
    if (*p < min_value) min_value = *p;
  for (const int *p = arr + 1; p < arr + len; ++p) 
    if (*p > max_value) max_value = *p;
}


void solve_1b(const int arr[], const size_t len, int& min_value, int& max_value)
{
  int max_v = arr[0], min_v = arr[0];
  for (const int *p = arr + 1; p < arr + len; ++p) 
    if (*p < min_v) min_v = *p;
  for (const int *p = arr + 1; p < arr + len; ++p) 
    if (*p > max_v) max_v = *p;
  max_value = max_v;
  min_value = min_v;
}


void solve_2a(const int arr[], const size_t len, int& min_value, int& max_value)
{
  int max_v = arr[0], min_v = arr[0];
  for (const int *p = arr + 1; p < arr + len; ++p) {
    if (*p < min_v) min_v = *p;
    if (*p > max_v) max_v = *p;
  }
  max_value = max_v;
  min_value = min_v;
}

void solve_2b(const int arr[], const size_t len, int& min_value, int& max_value)
{
  int max_v = arr[0], min_v = arr[0];
  for (const int *p = arr + 1; p < arr + len; ++p) {
    if (*p < min_v) min_v = *p;
    else if (*p > max_v) max_v = *p;
  }
  max_value = max_v;
  min_value = min_v;
}

void solve_3a(const int arr[], const size_t len, int& min_value, int& max_value)
{
  // int min_v = std::numeric_limits<int>::max();
  // int max_v = std::numeric_limits<int>::min();
  // const int *low = arr - 1;
  // const int *high = arr + len;
  
  const int *low = arr;
  const int *high = arr + len - 1;
  int min_v, max_v;
  if (*low < *high) { min_v = *low; max_v = *high; }
  else { min_v = *high; max_v = *low; }

  while (++low <= --high) {
    if (*low <= *high) {
      if (*low < min_v) min_v = *low;
      if (*high > max_v) max_v = *high;
    } else {
      if (*high < min_v) min_v = *high;      
      if (*low > max_v) max_v = *low;
    }
  }
  max_value = max_v;
  min_value = min_v;
}


void solve_3b(const int arr[], const size_t len, int& min_value, int& max_value)
{
  // Ϊ桢żʱֱȡ12ԪءʣµԪظһż
  int min_v, max_v;
  size_t t = (len - 1u) % 2u;
  if (arr[0] <= arr[t]) { min_v = arr[0];  max_v = arr[t]; }
  else { min_v = arr[t];  max_v = arr[0]; }
  
  const int *p = arr + t + 1;
  while (p < arr + len) {      // p  arr + len żʼͬ
    int va = *p++;
    int vb = *p++;
    if (va <= vb) {
      if (va < min_v) min_v = va; 
      if (vb > max_v) max_v = vb;
    } else {
      if (vb < min_v) min_v = vb;
      if (va > max_v) max_v = va;
    }
  }
  
  max_value = max_v;
  min_value = min_v;
}

void solve_3c(const int arr[], const size_t len, int& min_value, int& max_value)
{
  // Ϊ桢żʱֱȡ12ԪءʣµԪظһż
  int min_v, max_v;
  size_t t = (len - 1u) % 2u;
  if (arr[0] <= arr[t]) { min_v = arr[0];  max_v = arr[t]; }
  else { min_v = arr[t];  max_v = arr[0]; }
  
  
  for (const int *p = arr + t + 1; p < arr + len; p += 2) { // p  arr + len żʼͬ
    int va = *p;
    int vb = *(p + 1);
    if (va <= vb) {
      if (va < min_v) min_v = va; 
      if (vb > max_v) max_v = vb;
    } else {
      if (vb < min_v) min_v = vb;
      if (va > max_v) max_v = va;
    }
  }
  
  max_value = max_v;
  min_value = min_v;
}


static void solve_4a_(const int arr[], size_t low, size_t high, int& min_value, int& max_value)
{
  if (high - low <= 1u) {
    if (arr[low] <= arr[high]) { min_value = arr[low];  max_value = arr[high]; }
    else { min_value = arr[high];  max_value = arr[low]; }
    return;
  }
  
  size_t mid = low + (high - low) / 2u;
  int min_left, max_left;
  solve_4a_(arr, low, mid, min_left, max_left);
  
  int min_right, max_right;
  solve_4a_(arr, mid + 1, high, min_right, max_right);

  min_value = std::min(min_left, min_right);
  max_value = std::max(max_left, max_right);
}


void solve_4a(const int arr[], const size_t len, int& min_value, int& max_value)
{
  return solve_4a_(arr, 0, len - 1u, min_value, max_value);
}


struct Range{
  int min_v, max_v;
  Range(int x, int y):min_v(x), max_v(y) {}
};


static Range solve_4b_(const int arr[], size_t low, size_t high)
{
  if (high - low <= 1) {
    if (arr[low] <= arr[high]) return Range(arr[low], arr[high]);
    return Range(arr[high], arr[low]);
  }
  size_t mid = low + (high - low) / 2u;
  Range left = solve_4b_(arr, low, mid);
  Range right = solve_4b_(arr, mid + 1, high);
  return Range(std::min(left.min_v, right.min_v),std::max(left.max_v, right.max_v));
}

void solve_4b(const int arr[], const size_t len, int& min_value, int& max_value)
{
  Range value =  solve_4b_(arr, 0, len - 1);
  min_value = value.min_v;
  max_value = value.max_v;
}

static void solve_4c_(const int *low, const int *high, int& min_value, int& max_value)
{
  if (high - low <= 1) {
    if (*low <= *high)  { min_value = *low; max_value = *high; }
    else { min_value = *high; max_value = *low; }
	return;
  }
  const int *mid = low + (high - low) / 2u;
  int min_left, max_left;
  solve_4c_(low, mid, min_left, max_left);
  
  int min_right, max_right;
  solve_4c_(mid + 1, high, min_right, max_right);
  
  min_value = std::min(min_left, min_right);
  max_value = std::max(max_left, max_right);
}


void solve_4c(const int arr[], const size_t len, int& min_value, int& max_value)
{
  return solve_4c_(arr, arr + len - 1, min_value, max_value);
}


static Range solve_4d_(const int *low, const int *high)
{
  if (high - low <= 1) {
    if (*low <= *high) return Range(*low, *high);
    return Range(*high, *low);
  }
  const int* mid = low + (high - low) / 2u;
  Range left = solve_4d_(low, mid);
  Range right = solve_4d_(mid + 1, high);
  return Range(std::min(left.min_v, right.min_v),std::max(left.max_v, right.max_v));
}

void solve_4d(const int arr[], const size_t len, int& min_value, int& max_value)
{
  Range value =  solve_4d_(arr, arr + len - 1);
  min_value = value.min_v;
  max_value = value.max_v;
}




template<typename T>
void run_test(T arr[], size_t len, int input[], size_t input_len)
{
  int min_value, max_value;
  for (size_t i = 0; i < len; ++i) {
    printf("%d %-20s  ", i, arr[i].str);
    unsigned ta = mclock();
    for (size_t j = Pack; j != 0; --j)
      arr[i].func(input, input_len, min_value, max_value);
    ta = mclock() - ta;
    printf("min/max: %d/%d   elapsed: %u ms\n", min_value, max_value, ta / Pack);
  }
  printf("\n");
}

struct Func {
  void (*func)(const int arr[], const size_t len, int& min_value, int& max_value);
  const char *str; 
}; 
  
struct Generator {
  int operator()() const { return (rand() << 15) + rand(); }
};
  
void test()
{
  const size_t N = Length;
  if (Fix_M == 0 || N < 100) return;
  const Func func[] = {
    { solve_1a, " 1a α" },
    { solve_1b, " 1b αŻ" },
    { solve_2a, " 2a һα" },
    { solve_2b, " 2b һαŻ" },
    { solve_3a, " 3a ȡͷβԪ" },
    { solve_3b, " 3b ȡԪ" },
    // { solve_3c, " 3c ȡԪ2" },
#if ! TEST_CASE	
    { solve_4a, " 4a η" },
    { solve_4b, " 4b ηŻ" }, 
    // { solve_4c, " 4c η2" },             //
    // { solve_4d, " 4d ηŻ2" },     // ָ룬ٶȻԿ
#endif

  };
  
  const size_t func_len = sizeof(func) / sizeof(func[0]);
  std::vector<int> src(N);
  for (size_t i = 0; i < N; ++i) src[i] = i; 
  
#if ! TEST_CASE	  
  printf("   pos: 0  len:%u\n", N);
  run_test(func, func_len, &src[0], N);
  for (size_t i = 0; i < N; ++i) src[i] = N - i; 
  printf(" ݼ  pos: 0  len:%u\n", N);
  run_test(func, func_len, &src[0], N);
#endif  
  
  // srand(time(NULL));
  
  for (unsigned i = 0; i < Fix_M; ++i) {
  #if RANDOM_SHUFFLE
    std::random_shuffle(src.begin(), src.end());
  #else	
    std::generate(src.begin(), src.end(), Generator());
  #endif	
    printf (" %d pos: 0  len %u\n", i + 1, N);
    run_test(func, func_len, &src[0], N);
  }
 
#if TEST_RAND_POS 
  const unsigned sub_len = N / 4u;
  const unsigned max_pos = N  - sub_len;
  for (unsigned i = 0; i < Rand_M; ++i) {
    size_t pos = rand() % max_pos;
    printf ("  pos: %u   len %u\n", pos, sub_len);
    run_test(func, func_len, &src[pos], sub_len);  
  }
#endif  

}


int main()
{
  const HANDLE handle = GetCurrentProcess();
  SetPriorityClass(handle, REALTIME_PRIORITY_CLASS);
  SYSTEM_INFO info;
  GetSystemInfo(&info);
  const int num = info.dwNumberOfProcessors;
  if (num > 1) SetProcessAffinityMask(handle, num); 
  test();
}

